(**********************************************************************
*                                                                     *
*     ନ : Term_200, Term_Random, Term_Bad,         *
*      ⠪  뫪-ਥ ᮮ饭 Sender-Receiver       *
*                                                                     *
**********************************************************************)
{$O-}
                             unit  Demo_Un2;
                               interface

uses  Objects, Drivers, Views, Menus, TextView, Dialogs, App,
      MsgBox, StdDlg, Crt,
      Figaro, FigaroDG, FigaroIO, WinProcs, Commands;

procedure MakeTerminal_200;
procedure MakeTerminal_Random;
procedure MakeTerminal_Bad;
procedure MakeSender;
procedure MakeReceiver;
procedure MakeRotate;
{}
                             implementation
{}

const       {  ⥪ }

       CStack200    = 2500;
       CStackRandom = 2500;
       CStackBad    = 2500;
       CStackSend   = 2100;
       CStackReceive = 2100;
       CStackRotate = 1000;

        CQuant= MaxInt;      {  ६ ᮢ }
{}

procedure Process_Terminal_200;
var P : PWinTerminal;
    r1,r2 : longint;
    MyName,s,t : string;
begin
  StartPause;
  P:= PWinTerminal(Get_MyParamPtr);
  if not Assigned(P) then  Delete_Process('');
  MyName:=Get_MyName;
  repeat
    r1:=Get_TimeFromStart;
    Pause(CSecond);
    r2:=Get_TimeFromStart;
    Str ((r2-r1):3, t);  Insert('.',t,Length(t)-2);
    s:=MyName{+': '+t};
    Str (r2:9, t);       Insert('.',t,Length(t)-2);
    s:=s+' :'+t+' s';
    P^.Writeln (s);
  until false;
end;
{}
procedure MakeTerminal_200;
const  count : word = 0;
var    R     : TRect;
       s: string;
begin
   R.Assign (0,0,40,10);   R.Move(random(40),random(12));
   Inc (count);
   Str (count, s);
   s:='Term_200 # '+s;

   Disable_Interrupt;
   Application^.InsertWindow (New(PWinTerminal,
        Init(R, s,
        New(PProcessTerm,
        Init(s, true, 200, CQuant, 0, Stack(CStack200),
             @Process_Terminal_200, nil)))));
   Enable_Interrupt;

end;
{}
procedure Process_Terminal_Random;
var P : PWinTerminal;
    res, r1, r2 : longint;
    MyName, s, t : string;
begin
  StartPause;
  P:= PWinTerminal(Get_MyParamPtr);
  if not Assigned(P) then  Delete_Process('');
  MyName:=Get_MyName;
  repeat
    r1:=Get_TimeFromStart;
    Pause(CSecond);
    r2:=Get_TimeFromStart;
    Str ((r2-r1):3, t);  Insert('.',t,Length(t)-2);
    s:=MyName{+': '+t};
    Str (r2:9, t);       Insert('.',t,Length(t)-2);
    s:=s+' :'+t+' s';
    P^.Writeln (s);
    Set_Priory('',integer(400+Random(50)));
  until false;
end;
{}
procedure MakeTerminal_Random;
const   count : word = 0;
var     R     : TRect;
        s     : string;
        w     : PWinTerminal;
begin
   R.Assign (0,0,40,10);   R.Move(random(45),random(12));
   Inc (count);
   Str (count, s);
   s:='Term_Random # '+s;
   Disable_Interrupt;
   w:= (New(PWinTerminal,
            Init(R, s,   New(PProcessTerm,
                 Init(s, true, 400,  CQuant,  0, Stack(CStackRandom),
                      @Process_Terminal_Random, nil)))));
   if Assigned(w)
      then Application^.InsertWindow (w);
   Enable_Interrupt;
end;
{}
procedure Process_Terminal_Bad;
var P     : PWinTerminal;
    t1,t2 : longint;
    MyName, s, t : string;
begin
  StartPause;
  P:= PWinTerminal(Get_MyParamPtr);
  if not Assigned(P) then  Delete_Process('');
  MyName:=Get_MyName;
  repeat
    t1:=Get_TimeFromStart;
    {Delay(1000);                { <- Bad procedure ! }
    t2:=Get_TimeFromStart;
    Str ((t2-t1):5, t);  Insert('.',t,Length(t)-2);
    s:=MyName+' : '+t;
    Str (t2:7, t);  Insert('.',t,Length(t)-2);
    s:=s+' :'+t+' s';
    P^.Writeln (s);
    if Get_Mode = rgPseudo then  Pause(CSecond);
  until false;
end;
{}
procedure MakeTerminal_Bad;
const  count : word = 0;
var    R     : TRect;
var s: string;
begin
   R.Assign (0,0,40,10);   R.Move(random(40),random(12));
   Inc (count);
   Str (count, s);
   s:='Term_Bad # '+s;
   Disable_Interrupt;
   Application^.InsertWindow (New(PWinTerminal,
        Init(R, s,
        New(PProcessTerm,
        Init(s, true, 500,  CQuant,  0, Stack(CStackBad),
             @Process_Terminal_Bad, nil)))));
   Enable_Interrupt;
end;
{}

const  CReceiverName = 'Receiver '#17'';
const  CSenderName   = 'Sender '#16' ';

procedure Process_Sender;
var msg : PMsgText;
    win : PWinTerminal;
    s   : string;
    err : word;
begin
  StartPause;
  win:= PWinTerminal(Get_MyParamPtr);
  if not Assigned (win) then Delete_Process('');
  repeat
    Pause ((CSecond div 2)+Random(CSecond));
    Str(Get_TimeFromStart:8, s);  Insert('.',s,Length(s)-2);
    s:= Get_MyName+' '+s;
    New(msg, Init(s));
    err:=Send_Msg(CReceiverName, CSecond, msg);
    if err<>OK then begin
       s:= Get_ErrText(err);
       Delete_Msg(PMsg(msg))
    end;
    win^.Writeln (s);
  until false;
end;

procedure Process_Receiver;
var msg : PMsgText;
    win : PWinTerminal;
    s   : string;
    err : word;
begin
  StartPause;
  win:= PWinTerminal(Get_MyParamPtr);
  if not Assigned (win) then Delete_Process('');
  repeat
    Pause ((CSecond div 10)+Random(CSecond div 5));
    msg:=PMsgText (Get_Msg('', CSecond, err));
    s:= Get_ErrText(err);
    if err=OK then begin
       s:=PString(msg^._DataPtr)^;
       Delete_Msg(PMsg(msg))
    end;
    win^.Writeln (s);
  until false;
end;
{}

procedure MakeSender;
const   count : word = 0;
var     R     : TRect;
var s: string;
begin
   R.Assign (0,0,40,10);   R.Move(random(40),random(12));
   Inc (count);
   Str (count, s);
   s:=CSenderName + s;
   Disable_Interrupt;
   Application^.InsertWindow (New(PWinTerminal,
        Init(R, s,
        New(PProcessTerm,
        Init(s, true, 300, CQuant, 0, Stack(CStackSend),
             @Process_Sender, nil)))));
   Enable_Interrupt;
end;

procedure MakeReceiver;
var   R  : TRect;
begin
   R.Assign (0,0,40,10);   R.Move(random(40),random(12));
   if Get_ProcessPtr(CReceiverName)<> nil then exit;
   Disable_Interrupt;
   Application^.InsertWindow (New(PWinTerminal,
    Init(R, CReceiverName,
    New(PProcessTerm,
    Init(CReceiverName, true, 150, CQuant, 8, Stack(CStackReceive),
         @Process_Receiver, nil)))));
   Enable_Interrupt;
end;
{}
{$F+}
procedure Process_Rotate;
begin
  repeat
    Pause(CSecond);
    Rotate (200, 300);
  until false;
end;
{$F-}

procedure MakeRotate;
begin
   if Get_ProcessPtr('Rotate')<> nil then exit;
   Disable_Interrupt;
   Insert_Process (New(PProcess,  Init('Rotate', true,
                   110, CQuant, 0, Stack(CStackRotate),
                   @Process_Rotate, nil)));
   Enable_Interrupt;
end;

end.
